package provide DS9 1.0

proc InitExternalFile {} {
    global ds9

    # look for local version
    ProcessExternalFile "./$ds9(extFile)"

    # look for $HOME version
    ProcessExternalFile "~/$ds9(extFile)"
}

proc ProcessExternalFile {fn} {
    global externalType
    global externalCmd

    set status 1
    if [file exists "$fn"] {
	set id [open $fn r]
	while {[gets $id line] >= 0} {
	    # empty line
	    if {[string length $line] == 0} continue
	    # comments	    
	    if {[string range $line 0 0] == "\#"} continue
	    # else
	    switch $status {
		1 {
		    # eat the line
		    set template ""
		    set status 2
		}
		2 {
		    set template "$line"
		    set status 3
		}
		3 {
		    # eat the line
		    set status 4
		}
		4 {
		    if {"$template" != "" && "$line" != ""} {
			foreach t $template {
			    set f [file extension "$t"]
			    if {"$f" == ""} {
				set f [file rootname "$t"]
			    }
			    if {"$f" != ""} {
				set externalType($f) "$t"
				set externalCmd($f) "$line"
			    }
			}
		    }

		    set status 1
		}
	    }
	}
	close $id
    }
}

