package provide DS9 1.0

proc DisplayLog {item} {
    global ds9
    global log

    set mb $log(mb)

    # see if we already have a log window visible

    if {![winfo exist $log(top)]} {

	set title "Message Log"

	# create the log window

	toplevel $log(top)
	wm title $log(top) $title
	wm iconname $log(top) $title
	wm group $log(top) $ds9(top)

	$log(top) configure -menu $mb

	# simple menus

	menu $mb -tearoff 0
	$mb add cascade -label File -menu $mb.file
	$mb add cascade -label Edit -menu $mb.edit

	menu $mb.file -tearoff 0
	$mb.file add command -label "Print..." \
	    -command [list PrintLog] -state disabled
	$mb.file add separator
	$mb.file add command -label "Close" -command [list DestroyLog]

	menu $mb.edit -tearoff 0
	$mb.edit add command -label "Cut" -state disabled
	$mb.edit add command -label "Copy" -command [list CopyLog]
	$mb.edit add command -label "Paste" -state disabled
	$mb.edit add command -label "Clear" -command [list ClearLog]

	# create the text and scroll widgets
	
	set t [text $log(top).text -height 40 -width 80 -wrap none -font courier \
		   -yscrollcommand "$log(top).yscroll set" \
		   -xscrollcommand "$log(top).xscroll set"]
	
	set sy [scrollbar $log(top).yscroll -command [list $t yview] -orient vertical]
	set sx [scrollbar $log(top).xscroll -command [list $t xview] -orient horizontal]
	grid $t $sy -sticky news
	grid $sx -stick news
	grid rowconfigure $log(top) 0 -weight 1
	grid columnconfigure $log(top) 0 -weight 1

	$t configure -state disabled
    }

    # insert the log item into the text widget

    $log(top).text configure -state normal
    $log(top).text insert end $item
    $log(top).text configure -state disabled
}

proc DestroyLog {} {
    global log
    
    destroy $log(top)
    destroy $log(mb).file
    destroy $log(mb).edit
    destroy $log(mb)
}

proc CopyLog {} {
    global log

    clipboard clear -displayof $log(top)
    clipboard append -displayof $log(top) [selection get -displayof $log(top)]
}

proc PrintLog {} {
    global log

    tk_messageBox -message "Sorry, Not Implemented." \
	-parent $log(top) -type ok -icon info
}

proc ClearLog {} {
    global log

    if {[winfo exist $log(top)]} {
	$log(top).text configure -state normal
	$log(top).text delete 1.0 end
	$log(top).text configure -state disabled
    }
}
