package provide DS9 1.0

proc PolygonDialog {frame id} {
    global marker

    # see if we already have a header window visible

    set w ".marker$id"
    set mb ".mb$id"

    if [winfo exist $w] {
	return
    }

    # Init common items

    InitMarkerDialog $frame $id
    PropMenuPolygonDialog $frame $mb $id
    CoordMenuMarkerDialog $frame $mb $id MoveMarkerCB

    # Init polygon variables

    EditPolygonCB $frame $id
    RotatePolygonCB $frame $id

    # polygon specific callbacks

    $frame marker $id callback edit EditPolygonCB $frame
    $frame marker $id callback rotate RotatePolygonCB $frame
    $frame marker $id callback delete DeletePolygonDialog $frame

    # Dialog

    CommonMarkerDialog $frame $id

    label $w.ref.angleTitle -text "Angle"
    entry $w.ref.angle -textvariable marker($frame,$id,angle) \
	-width 13 -relief sunken -bd 2
    label $w.ref.angleUnit -relief groove -bd 2 -width 9 -padx 4 -text "degrees"

    grid $w.ref.angleTitle -row 1 -column 0 -padx 4 -sticky w
    grid $w.ref.angle -row 1 -column 1 -padx 4 -sticky w
    grid $w.ref.angleUnit -row 1 -column 3 -padx 4 -sticky w

    # Buttons

    button $w.buttons.apply -text "Apply" \
	-command "ApplyPolygonDialog $frame $id"
    button $w.buttons.close -text "Close" \
	-command "ClosePolygonDialog $frame $id"
    pack $w.buttons.apply $w.buttons.close -side left -padx 10 -expand true

    bind $w <Return> "ApplyPolygonDialog $frame $id"
}

proc ApplyPolygonDialog {frame id} {
    EditPolygonDialog $frame $id
    RotatePolygonDialog $frame $id
    ApplyMarkerDialog $frame $id
}

proc ClosePolygonDialog {frame id} {
    global marker

    unset marker($frame,$id,angle)

    $frame marker $id delete callback edit EditPolygonCB
    $frame marker $id delete callback rotate RotatePolygonCB
    $frame marker $id delete callback delete DeletePolygonDialog
    DeleteMarkerCBs $frame $id

    DeleteMarkerDialog $frame $id
}

proc DeletePolygonDialog {frame id} {
    global marker

    unset marker($frame,$id,angle)

    DeleteMarkerDialog $frame $id
}

proc EditPolygonDialog {frame id} {
    global marker
}

proc RotatePolygonDialog {frame id} {
    global marker

    $frame marker $id polygon angle $marker($frame,$id,angle)
}

proc EditPolygonCB {frame id} {
    global marker

}

proc RotatePolygonCB {frame id} {
    global marker

    set marker($frame,$id,angle) [$frame get marker $id polygon angle]
}

proc PropMenuPolygonDialog {frame mb id} {
    global menu
    global marker

    menu $mb.properties -tearoff 0 -selectcolor $menu(selectcolor)
    $mb.properties add checkbutton -label "Can Edit" \
	-variable marker($frame,$id,edit) \
	-command "PropertyMarkerDialog $frame $id edit"
    $mb.properties add checkbutton -label "Can Move" \
	-variable marker($frame,$id,move) \
	-command "PropertyMarkerDialog $frame $id move"
    $mb.properties add checkbutton -label "Can Rotate" \
	-variable marker($frame,$id,rotate) \
	-command "PropertyMarkerDialog $frame $id rotate"
    $mb.properties add checkbutton -label "Can Delete" \
	-variable marker($frame,$id,delete) \
	-command "PropertyMarkerDialog $frame $id delete"
    $mb.properties add checkbutton -label "Include/Exclude" \
	-variable marker($frame,$id,include) \
	-command "PropertyMarkerDialog $frame $id include"
}

