#include "channel.h"

FitsChannel::FitsChannel(Tcl_Interp* interp, const char* ch, const char* ext) 
{
  parse(ext);

  int tclMode;
  stream_ = Tcl_GetChannel(interp, (char*)ch, &tclMode);
}

FitsFitsChannel::FitsFitsChannel(Tcl_Interp* interp, const char* ch, const char* ext,
				 ScanMode mode) : FitsChannel(interp, ch, ext)
{
  if (stream_)
    if (mode == EXACT || pExt_ || pIndex_)
      processExact();
    else
      processRelax();
}

FitsArrChannel::FitsArrChannel(Tcl_Interp* interp, const char* ch, const char* ext)
  : FitsChannel(interp, ch, ext)
{
  if (stream_)
    processArray();
}

FitsMosaicChannel::FitsMosaicChannel(Tcl_Interp* interp, const char* ch)
  : FitsChannel(interp, ch, "")
{
  if (stream_)
    processMosaic();
}

FitsMosaicNextChannel::FitsMosaicNextChannel(FitsFile* ff)
{
  processMosaicNext(ff);
}
