#ifndef __fitsstream_h__
#define __fitsstream_h__

#include <tcl.h>
#include "file.h"

template<class T>
class FitsStream : public FitsFile {
private:
  int seek_;

protected:
  T stream_;

  void processExact();
  void processRelax();
  void processArray();
  void processMosaic();
  void processMosaicNext(FitsFile*);

private:
  int read(char*, int);
  int tell();
  int seek(int);
  void close();

  // there is a major problem with seek (both TCL_Channel and FILE*)
  // so turn it off for now
  // int canSeek() {return (seek_>=0);}

  int canSeek() {return 0;}
  FitsHead* headRead();
  void* dataRead(int);
  void dataSkip(int);

public:
  FitsStream();
  ~FitsStream();

  T stream() {return stream_;}
};

#endif
