#ifndef __frametrue_h__
#define __frametrue_h__

#include "frame.h"

class FrameTrueColor : public Frame {
protected:
  int skipUpdate;

  XImage* colormapXM;      // rotate dest ximage
  Pixmap colormapPM;       // rotate pixmap
  GC colormapGCXOR;        // GC for interactive rotation
  long* colormapData;

protected:
  virtual void updateColorScale() =0;

  void fillXImage(XImage*, Matrix& (FitsImage::*)());
  void fillXImageMosaic(XImage*, Matrix& (FitsImage::*)());
  void clearPixmap(Pixmap, XImage*);
  void updateMagnifierReplicate(const Vector&);
  void rotateMotion();

  void colormapBeginSingle();
  void colormapBeginMosaic();

public:
  FrameTrueColor(Tcl_Interp*, Tk_Canvas, Tk_Item*);
  virtual ~FrameTrueColor();

  void colormapCmd(int, float, float, int, unsigned short*, unsigned char*, int);
  void colormapBeginCmd();
  void colormapMotionCmd(int, float, float, int, unsigned short*, unsigned char*, int);
  void colormapEndCmd(int, float, float, int, unsigned short*, unsigned char*, int);
};

#endif
