#ifndef __ruler_h__
#define __ruler_h__

#include "marker.h"

class Ruler : public Marker {
private:
  Vector p2;
  Vector p3;
  int coordSystem;
  int coordFormat;
  Vector axisDist;
  double dist;

  void render(Drawable, const Matrix&, GC);
  void renderValue(Drawable, Vector, double, GC);
  void psValue(int, Vector, double);
  void calcP3();
  void calcDist();
  void calcAxisDist();

public:
  Ruler(Frame* parent, const Vector& ctr, const Vector& p, int,
	const char* clr, const char* f, const char* t, unsigned short prop);

  void updateBBox();
  void updateCoords(Matrix&);
  void draw();
  void drawXOR();
  void drawMagnifier(const Matrix&);
  void move(const Vector&);
  void moveTo(const Vector&);
  void edit(const Vector&, int);
  void ps(int);
  int isIn(const Vector&);

  const Vector& getP1() {return center;}
  const Vector& getP2() {return p2;}
  void setP1(const Vector&);
  void setP2(const Vector&);
  void setSystem(int, int);

  double getDistance() {return dist;}
  Vector getAxisDistance() {return axisDist;}

  void list(ostream&, int, int);
};

#endif
